
local pump = data.raw['offshore-pump']['offshore-pump'] -- real offshore pump
pump.pumping_speed = 5 -- 5 is 300 fluids/s, vanilla has speed 20 and 1200 fluids/s

local burner_offshore_pump = table.deepcopy (pump) -- assembling machine

burner_offshore_pump.type = 'assembling-machine'
burner_offshore_pump.name = 'burner-offshore-pump'
table.insert (burner_offshore_pump.flags, "placeable-off-grid")
burner_offshore_pump.localised_name = {'entity-name.offshore-pump'}
burner_offshore_pump.placeable_by = {item='offshore-pump', count=1}
burner_offshore_pump.fluid_boxes = {fluid_box =
    {
      base_area = 1,
      base_level = 1,
      pipe_covers = pipecoverspictures(),
      production_type = "output",
      filter = "water",
      pipe_connections = {{position = {0, 1}, type = "output"}}
    }, off_when_no_fluid_recipe = false}
burner_offshore_pump.crafting_categories = {"bop-fluids-making"}
burner_offshore_pump.fixed_recipe = "bop-make-water"
burner_offshore_pump.crafting_speed = 1
burner_offshore_pump.energy_source =
      {
        type = "burner",
        fuel_category = "chemical",
        effectivity = 1,
        fuel_inventory_size = 1,
        emissions_per_minute = 3
      }
burner_offshore_pump.energy_usage = "600kW"
burner_offshore_pump.order = "b-o-p"
burner_offshore_pump.trigger_created_entity = true
burner_offshore_pump.animation = burner_offshore_pump.picture
    




local recipe_category = {name = "bop-fluids-making", type = "recipe-category"}

local fixed_recipe = {
  type = 'recipe',
  name = 'bop-make-water',
  category = 'bop-fluids-making',
  hidden = true,
  icon = "__base__/graphics/icons/fluid/water.png",
  icon_size = 32,
  energy_required = 1,
  ingredients = {},
  results = {{type = "fluid", name = "water", amount = 300}},
  subgroup = "fluid-recipes",
}

data:extend ({burner_offshore_pump, recipe_category, fixed_recipe})

